package Staartvin.SimpleRegister.Emailer;

import org.bukkit.scheduler.BukkitRunnable;

import Staartvin.SimpleRegister.SimpleRegister;
 
public class sendEmailTask extends BukkitRunnable {
 
    private final SimpleRegister plugin;
    private String recipient;
 
    
    /**
     * Schedule a new e-mail.
     * @param plugin SimpleRegister plugin
     * @param recipient email address to sent the e-mail to.
     */
    public sendEmailTask(SimpleRegister plugin, String recipient) {
        this.plugin = plugin;
        this.recipient = recipient;
    }
 
    public void run() {
         if (new Emailer(plugin, recipient).email()) {
        	 //System.out.print("Email has been sent!");
         }
    }
 
}