package Staartvin.SimpleRegister;

import java.io.File;
import java.util.HashMap;
import java.util.HashSet;

//import me.pogostick29.emailapi.EmailAPI;

import org.bukkit.command.CommandExecutor;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.plugin.java.JavaPlugin;

import Staartvin.SimpleRegister.API.API;
import Staartvin.SimpleRegister.FileHandling.LoadConfiguration;
import Staartvin.SimpleRegister.FileHandling.MessagesFile;
import Staartvin.SimpleRegister.Listeners.AcceptApplicationListener;
import Staartvin.SimpleRegister.Listeners.ChatListener;
import Staartvin.SimpleRegister.Listeners.DeclineApplicationListener;
import Staartvin.SimpleRegister.Listeners.PlayerJoinListener;

public class SimpleRegister extends JavaPlugin {

	
	public LoadConfiguration loadConfiguration = new LoadConfiguration(this);
	public FileConfiguration playersConfig;
	
	
	public File playersConfigFile;
	public MessagesFile messagesFile = new MessagesFile(this);
	public HashSet<String> players = new HashSet<String>();
	public boolean isAcceptApplicationCancelled = false;
	public boolean isDeclineApplicationCancelled = false;
	
	public HashMap<String, Boolean> isRegistering = new HashMap<String, Boolean>(); // Question 1
	public HashMap<String, Boolean> isRegistering2 = new HashMap<String, Boolean>(); // Question 2
	public HashMap<String, Boolean> isRegistering3 = new HashMap<String, Boolean>(); // Question 3
	public HashMap<String, Boolean> isRegistering4 = new HashMap<String, Boolean>(); // Question 4
	public HashMap<String, Boolean> isRegistering5 = new HashMap<String, Boolean>(); // Question 5
	public HashMap<String, Boolean> isRegistering6 = new HashMap<String, Boolean>(); // Question 6
	public HashMap<String, Boolean> isRegistering7 = new HashMap<String, Boolean>(); // Question 7
	public HashMap<String, Boolean> isRegistering8 = new HashMap<String, Boolean>(); // Question 8
	public HashMap<String, Boolean> isRegistering9 = new HashMap<String, Boolean>(); // Question 9
	public HashMap<String, Boolean> isRegistering10 = new HashMap<String, Boolean>(); // Question 10
	public HashMap<String, Boolean> isRegistering11 = new HashMap<String, Boolean>(); // Question 11
	
	protected HashMap<String, String> emailAddress = new HashMap<String, String>(); // Email address to use for EmailAPI.

	CommandExecutor CommandExecutor = new SimpleRegisterCommandExecutor(this);
	public MessageHandling messages = new MessageHandling(this);
	public Methods methods = new Methods(this);
	//EmailAPI emailapi;
	
	public String Question1;
	public String Question2;
	public String Question3;
	public String Question4;
	public String Question5;
	public String Question6;
	public String Question7;
	public String Question8;
	public String Question9;
	public String Question10;
	
	public void onEnable() {
		loadConfiguration.loadConfiguration();
		messagesFile.loadMessages();
		
		getCommand("simpleregister").setExecutor(CommandExecutor);
		getCommand("register").setExecutor(CommandExecutor);
		
		getCommand("accept").setExecutor(CommandExecutor);

		getCommand("deny").setExecutor(CommandExecutor);
		
		getCommand("view").setExecutor(CommandExecutor);
		
		/*if (getServer().getPluginManager().getPlugin("EmailAPI") == null) {
			System.out.print("[SimpleRegister] EmailAPI has not been found and therefore cannot be used!");
		} else {
			 emailapi = new EmailAPI().getInstance();
		}*/
		getCommand("applications").setExecutor(CommandExecutor);
		
		getServer().getPluginManager().registerEvents(new ChatListener(this) , this);
		getServer().getPluginManager().registerEvents(new PlayerJoinListener(this) , this);
		getServer().getPluginManager().registerEvents(new AcceptApplicationListener(this) , this);
		getServer().getPluginManager().registerEvents(new DeclineApplicationListener(this) , this);
		
		System.out.print("[SimpleRegister] activation.jar and mail.jar have been found! Mail can be used!");
		
		System.out.print("[SimpleRegister] SimpleRegister v" + getDescription().getVersion() + " has been enabled!");
	}
	
	public void onDisable() {
		reloadConfig();
		saveConfig();
		loadConfiguration.reloadRegistrationsConfig();
		loadConfiguration.saveRegistrationsConfig();
		messagesFile.reloadMessagesConfig();
		messagesFile.saveMessagesConfig();
		
		getServer().getScheduler().cancelTasks(this);
		System.out.print("[SimpleRegister] SimpleRegister v" + getDescription().getVersion() + " has been disabled!");
	}
	
	public API getInstance() {
		return new API(this);
	}
}
