package Staartvin.SimpleRegister;

import java.util.List;

import org.bukkit.ChatColor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import Staartvin.SimpleRegister.FileHandling.MessagesFile.configMessages;

public class MessageHandling {

	SimpleRegister plugin;

	protected MessageHandling(SimpleRegister plugin) {
		this.plugin = plugin;
	}

	protected boolean isEmailMessage(String questionName) {
			if (plugin.getConfig().getString("EmailAPI.emailQuestion")
					.equalsIgnoreCase(questionName)) {
				return true;
			}
		return false;
	}

	protected void message(CommandSender sender) {
		if (!sender.hasPermission("simpleregister.register")) {
			sender.sendMessage(ChatColor.RED
					+ "You don't have the permission to perform this command!");
			return;
		}
		if (!(sender instanceof Player)) {
			sender.sendMessage(ChatColor.RED
					+ "Only players can perform this command!");
			return;
		}
		if (plugin.playersConfig.getString(sender.getName().toLowerCase()
				+ ".Status") == null)
			plugin.loadConfiguration.readInfo(sender.getName());
		if (plugin.playersConfig.getString(
				sender.getName().toLowerCase() + ".Status").equalsIgnoreCase(
				"accepted")) {
			sender.sendMessage(plugin.messagesFile.getMessage(configMessages.ALREADY_ACCEPTED, sender.getName(), null));
			return;
		}
		if (plugin.playersConfig.getBoolean(sender.getName().toLowerCase()
				+ ".Registered")) {
			sender.sendMessage(plugin.messagesFile.getMessage(configMessages.ALREADY_REGISTERED, sender.getName(), null));
			return;
		}

		plugin.isRegistering.put(sender.getName(), true);
		sender.sendMessage(ChatColor.GRAY
				+ "---------------------------------------");
		sender.sendMessage(plugin.messagesFile.getMessage(configMessages.REGISTER_LINE_1, sender.getName(), null));
		sender.sendMessage(plugin.messagesFile.getMessage(configMessages.REGISTER_LINE_2, sender.getName(), null));
		sender.sendMessage(plugin.messagesFile.getMessage(configMessages.REGISTER_LINE_3, sender.getName(), null));
		plugin.players.add(sender.getName());
		return;
	}

	public void message2(Player player, String message) {
		plugin.reloadConfig();
		plugin.isRegistering.put(player.getName(), false);
		if (!(message.equalsIgnoreCase("yes"))) {
			player.sendMessage(ChatColor.GRAY
					+ "---------------------------------------");
			player.sendMessage(plugin.messagesFile.getMessage(configMessages.REGISTER_NO_LINE_1, player.getName(), null));
			player.sendMessage(plugin.messagesFile.getMessage(configMessages.REGISTER_STOP_REGISTRATION, player.getName(), null));
			plugin.players.remove(player.getName());
			return;
		}
		player.sendMessage(ChatColor.GRAY
				+ "---------------------------------------");
		player.sendMessage(plugin.messagesFile.getMessage(configMessages.REGISTER_YES_LINE_1, player.getName(), null));
		player.sendMessage(ChatColor.YELLOW
				+ plugin.methods.formatQuestion(
						plugin.getConfig().getString("Question1.Question"),
						player.getName()));
		plugin.players.add(player.getName());
		plugin.isRegistering2.put(player.getName(), true);
	}

	public void message3(Player player, String message) {

		plugin.isRegistering2.put(player.getName(), false);

		if (isEmailMessage("Question1")) {
			plugin.emailAddress
					.put(player.getName(), message.replaceAll(" ", "."));
		}
		
		plugin.playersConfig.set(player.getName().toLowerCase() + ".value1",
				message.toLowerCase());

		plugin.loadConfiguration.saveRegistrationsConfig();

		player.sendMessage(ChatColor.GRAY
				+ "---------------------------------------");
		player.sendMessage(plugin.messagesFile.getMessage(configMessages.REGISTER_ANSWER, player.getName(), message));
		if (!plugin.getConfig().getBoolean("Question2.Use")) {
			completeRegistration(player);
			return;
		}
		player.sendMessage(ChatColor.YELLOW
				+ plugin.methods.formatQuestion(
						plugin.getConfig().getString("Question2.Question"),
						player.getName()));
		plugin.isRegistering3.put(player.getName(), true);
	}

	public void message4(Player player, String message) {
		
		if (isEmailMessage("Question2")) {
			plugin.emailAddress
					.put(player.getName(), message.replaceAll(" ", "."));
		}
		
		plugin.playersConfig.set(player.getName().toLowerCase() + ".value2",
				message);

		plugin.isRegistering3.put(player.getName(), false);

		plugin.loadConfiguration.saveRegistrationsConfig();

		player.sendMessage(ChatColor.GRAY
				+ "---------------------------------------");
		player.sendMessage(plugin.messagesFile.getMessage(configMessages.REGISTER_ANSWER, player.getName(), message));
		if (!plugin.getConfig().getBoolean("Question3.Use")) {
			completeRegistration(player);
			return;
		}
		player.sendMessage(ChatColor.YELLOW
				+ plugin.methods.formatQuestion(
						plugin.getConfig().getString("Question3.Question"),
						player.getName()));
		plugin.isRegistering4.put(player.getName(), true);
	}

	public void message5(Player player, String message) {
		if (isEmailMessage("Question3")) {
			plugin.emailAddress
					.put(player.getName(), message.replaceAll(" ", "."));
		}

		plugin.playersConfig.set(player.getName().toLowerCase() + ".value3",
				message);

		plugin.isRegistering4.put(player.getName(), false);

		plugin.loadConfiguration.saveRegistrationsConfig();
		player.sendMessage(ChatColor.GRAY
				+ "---------------------------------------");
		player.sendMessage(plugin.messagesFile.getMessage(configMessages.REGISTER_ANSWER, player.getName(), message));
		if (!plugin.getConfig().getBoolean("Question4.Use")) {
			completeRegistration(player);
			return;
		}
		player.sendMessage(ChatColor.YELLOW
				+ plugin.methods.formatQuestion(
						plugin.getConfig().getString("Question4.Question"),
						player.getName()));
		plugin.isRegistering5.put(player.getName(), true);
	}

	public void message6(Player player, String message) {
		if (isEmailMessage("Question4")) {
			plugin.emailAddress
					.put(player.getName(), message.replaceAll(" ", "."));
		}
		
		plugin.playersConfig.set(player.getName().toLowerCase() + ".value4",
				message);

		plugin.isRegistering5.put(player.getName(), false);

		plugin.loadConfiguration.saveRegistrationsConfig();

		player.sendMessage(ChatColor.GRAY
				+ "---------------------------------------");
		player.sendMessage(plugin.messagesFile.getMessage(configMessages.REGISTER_ANSWER, player.getName(), message));
		if (!plugin.getConfig().getBoolean("Question5.Use")) {
			completeRegistration(player);
			return;
		}
		player.sendMessage(ChatColor.YELLOW
				+ plugin.methods.formatQuestion(
						plugin.getConfig().getString("Question5.Question"),
						player.getName()));
		plugin.isRegistering6.put(player.getName(), true);
	}

	public void message7(Player player, String message) {
		if (isEmailMessage("Question5")) {
			plugin.emailAddress
					.put(player.getName(), message.replaceAll(" ", "."));
		}
		
		plugin.playersConfig.set(player.getName().toLowerCase() + ".value5",
				message);

		plugin.isRegistering6.put(player.getName(), false);

		plugin.loadConfiguration.saveRegistrationsConfig();

		player.sendMessage(ChatColor.GRAY
				+ "---------------------------------------");
		player.sendMessage(plugin.messagesFile.getMessage(configMessages.REGISTER_ANSWER, player.getName(), message));
		if (!plugin.getConfig().getBoolean("Question6.Use")) {
			completeRegistration(player);
			return;
		}
		player.sendMessage(ChatColor.YELLOW
				+ plugin.methods.formatQuestion(
						plugin.getConfig().getString("Question6.Question"),
						player.getName()));
		plugin.isRegistering7.put(player.getName(), true);
	}

	public void message8(Player player, String message) {
		if (isEmailMessage("Question6")) {
			plugin.emailAddress
					.put(player.getName(), message.replaceAll(" ", "."));
		}
		
		plugin.playersConfig.set(player.getName().toLowerCase() + ".value6",
				message);

		plugin.isRegistering7.put(player.getName(), false);

		plugin.loadConfiguration.saveRegistrationsConfig();

		player.sendMessage(ChatColor.GRAY
				+ "---------------------------------------");
		player.sendMessage(plugin.messagesFile.getMessage(configMessages.REGISTER_ANSWER, player.getName(), message));
		if (!plugin.getConfig().getBoolean("Question7.Use")) {
			completeRegistration(player);
			return;
		}
		player.sendMessage(ChatColor.YELLOW
				+ plugin.methods.formatQuestion(
						plugin.getConfig().getString("Question7.Question"),
						player.getName()));
		plugin.isRegistering8.put(player.getName(), true);
	}

	public void message9(Player player, String message) {

		if (isEmailMessage("Question7")) {
			plugin.emailAddress
					.put(player.getName(), message.replaceAll(" ", "."));
		}
		
		plugin.playersConfig.set(player.getName().toLowerCase() + ".value7",
				message);

		plugin.isRegistering8.put(player.getName(), false);

		plugin.loadConfiguration.saveRegistrationsConfig();

		player.sendMessage(ChatColor.GRAY
				+ "---------------------------------------");
		player.sendMessage(plugin.messagesFile.getMessage(configMessages.REGISTER_ANSWER, player.getName(), message));
		if (!plugin.getConfig().getBoolean("Question8.Use")) {
			completeRegistration(player);
			return;
		}
		player.sendMessage(ChatColor.YELLOW
				+ plugin.methods.formatQuestion(
						plugin.getConfig().getString("Question8.Question"),
						player.getName()));
		plugin.isRegistering9.put(player.getName(), true);
	}

	public void message10(Player player, String message) {

		if (isEmailMessage("Question8")) {
			plugin.emailAddress
					.put(player.getName(), message.replaceAll(" ", "."));
		}
		
		plugin.playersConfig.set(player.getName().toLowerCase() + ".value8",
				message);

		plugin.isRegistering9.put(player.getName(), false);

		plugin.loadConfiguration.saveRegistrationsConfig();

		player.sendMessage(ChatColor.GRAY
				+ "---------------------------------------");
		player.sendMessage(plugin.messagesFile.getMessage(configMessages.REGISTER_ANSWER, player.getName(), message));
		if (!plugin.getConfig().getBoolean("Question9.Use")) {
			completeRegistration(player);
			return;
		}
		player.sendMessage(ChatColor.YELLOW
				+ plugin.methods.formatQuestion(
						plugin.getConfig().getString("Question9.Question"),
						player.getName()));
		plugin.isRegistering10.put(player.getName(), true);
	}

	public void message11(Player player, String message) {
		if (isEmailMessage("Question9")) {
			plugin.emailAddress
					.put(player.getName(), message.replaceAll(" ", "."));
		}
		
		plugin.playersConfig.set(player.getName().toLowerCase() + ".value9",
				message);

		plugin.isRegistering10.put(player.getName(), false);

		plugin.loadConfiguration.saveRegistrationsConfig();

		player.sendMessage(ChatColor.GRAY
				+ "---------------------------------------");
		player.sendMessage(plugin.messagesFile.getMessage(configMessages.REGISTER_ANSWER, player.getName(), message));
		if (!plugin.getConfig().getBoolean("Question10.Use")) {
			completeRegistration(player);
			return;
		}
		player.sendMessage(ChatColor.YELLOW
				+ plugin.methods.formatQuestion(
						plugin.getConfig().getString("Question10.Question"),
						player.getName()));
		plugin.isRegistering11.put(player.getName(), true);
	}

	public void message12(Player player, String message) {
		if (isEmailMessage("Question10")) {
			plugin.emailAddress
					.put(player.getName(), message.replaceAll(" ", "."));
		}
		
		plugin.playersConfig.set(player.getName().toLowerCase() + ".value10",
				message);

		plugin.isRegistering11.put(player.getName(), false);

		plugin.loadConfiguration.saveRegistrationsConfig();

		player.sendMessage(ChatColor.GRAY
				+ "---------------------------------------");
		player.sendMessage(plugin.messagesFile.getMessage(configMessages.REGISTER_ANSWER, player.getName(), message));

		completeRegistration(player);
	}

	protected void completeRegistration(Player player) {
		plugin.isRegistering.put(player.getName(), false);
		plugin.isRegistering2.put(player.getName(), false);
		plugin.isRegistering3.put(player.getName(), false);
		plugin.isRegistering4.put(player.getName(), false);
		plugin.isRegistering5.put(player.getName(), false);
		plugin.isRegistering6.put(player.getName(), false);
		plugin.isRegistering7.put(player.getName(), false);
		plugin.isRegistering8.put(player.getName(), false);
		plugin.isRegistering9.put(player.getName(), false);
		plugin.isRegistering10.put(player.getName(), false);

		plugin.playersConfig.set(
				player.getName().toLowerCase() + ".Registered", true);
		List<String> pendingapplications = plugin.playersConfig
				.getStringList("PendingApplications");
		pendingapplications.add(player.getName().toLowerCase());
		plugin.playersConfig.set("PendingApplications", pendingapplications);
		plugin.playersConfig.set(player.getName().toLowerCase() + ".Status",
				"pending");
		plugin.loadConfiguration.saveRegistrationsConfig();
		plugin.players.remove(player.getName());

		for (Player players : plugin.getServer().getOnlinePlayers()) {
			if (players.hasPermission("simpleregister.notice")) {
				players.sendMessage(ChatColor.BLUE + "[SimpleRegister] "
						+ (plugin.messagesFile.getMessage(configMessages.NEW_APP_FILED_NOTICE, player.getName(), null)));;
			}
		}
		player.sendMessage(ChatColor.GRAY
				+ "---------------------------------------");
		player.sendMessage(plugin.messagesFile.getMessage(configMessages.REGISTER_THANK_YOU, player.getName(), null));
		player.sendMessage(plugin.messagesFile.getMessage(configMessages.REGISTER_DONE_LINE_2, player.getName(), null));
		player.sendMessage(plugin.messagesFile.getMessage(configMessages.REGISTER_DONE_LINE_3, player.getName(), null));
	}
}
